/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "winner.h"

void pokerWinnerGetFullHand(poker_t *poker,pokerplayer_t *player,card_t *cards){
  uint8_t i;

  for(i = 0; i < poker->cardsFacing; i++) {
    cards[i] = poker->cards[i];
  }

  for(i = 0; i < player->cardCount; i++) {
    cards[i+poker->cardsFacing] = player->cards[i];
  }
}

void pokerWinnerInit(poker_t *poker) {
  uint8_t winners[POKER_PLAYER_COUNT];
  uint8_t winnerCount = 0;

  poker->round = POKER_ROUND_WINNER;
  printf("Winner Winner Chicken Dinner\n");

  // Find the player(s) who have a royal flush?
  for(uint8_t i = 0; i < POKER_PLAYER_COUNT; i++) {
    pokerplayer_t *player = poker->players + i;
    if(!pokerPlayerIsAlive(player)) continue;

    card_t fullHand[POKER_DEALER_HAND+POKER_PLAYER_HAND];
    pokerWinnerGetFullHand(poker, player, fullHand);
    uint8_t cardCount = poker->cardsFacing + player->cardCount;

    uint8_t suit;

    // Find the ace and get it's suit
    for(uint8_t j = 0; j < cardCount; j++) {
      card_t card = fullHand[j];
      if((card % CARD_COUNT_PER_SUIT) != CARD_ACE) continue;
      suit = card / CARD_COUNT_PER_SUIT;
      break;
    }

    // Now we have a suit, check we have each of that
  }
}